/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VCoreStudyRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreStudy extends TableImpl<VCoreStudyRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_core_study</code>
     */
    public static final VCoreStudy V_CORE_STUDY = new VCoreStudy();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreStudyRecord> getRecordType() {
        return VCoreStudyRecord.class;
    }

    /**
     * The column <code>common_dd.v_core_study.key_element</code>.
     */
    public final TableField<VCoreStudyRecord, Integer> KEY_ELEMENT = createField(DSL.name("key_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_study.study_element</code>.
     */
    public final TableField<VCoreStudyRecord, Integer> STUDY_ELEMENT = createField(DSL.name("study_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_study.study_id</code>.
     */
    public final TableField<VCoreStudyRecord, Integer> STUDY_ID = createField(DSL.name("study_id"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_study.study_name</code>.
     */
    public final TableField<VCoreStudyRecord, String> STUDY_NAME = createField(DSL.name("study_name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_study.token_data</code>.
     */
    public final TableField<VCoreStudyRecord, String> TOKEN_DATA = createField(DSL.name("token_data"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_study.token_config</code>.
     */
    public final TableField<VCoreStudyRecord, String> TOKEN_CONFIG = createField(DSL.name("token_config"), SQLDataType.CLOB, this, "");

    private VCoreStudy(Name alias, Table<VCoreStudyRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreStudy(Name alias, Table<VCoreStudyRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_study" as  WITH RECURSIVE t(k, p, path) AS (
                SELECT t_core_element_hierarchy.key_element,
                   t_core_element_hierarchy.key_parent_element,
                   ARRAY[]::integer[] AS "array"
                  FROM common_dd.t_core_element_hierarchy
                 WHERE (t_core_element_hierarchy.key_parent_element IS NULL)
               UNION ALL
                SELECT t_core_element_hierarchy.key_element,
                   t_core_element_hierarchy.key_parent_element,
                   (t_1.path || t_core_element_hierarchy.key_parent_element)
                  FROM (common_dd.t_core_element_hierarchy
                    JOIN t t_1 ON ((t_1.k = t_core_element_hierarchy.key_parent_element)))
               )
        SELECT t.k AS key_element,
           t_core_study.fk_element AS study_element,
           t_core_study.pk AS study_id,
           t_core_study.name AS study_name,
           t_core_study.token_data,
           t_core_study.token_config
          FROM t,
           common_dd.t_core_study
         WHERE (t_core_study.fk_element = ANY (t.path));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_study</code> table reference
     */
    public VCoreStudy(String alias) {
        this(DSL.name(alias), V_CORE_STUDY);
    }

    /**
     * Create an aliased <code>common_dd.v_core_study</code> table reference
     */
    public VCoreStudy(Name alias) {
        this(alias, V_CORE_STUDY);
    }

    /**
     * Create a <code>common_dd.v_core_study</code> table reference
     */
    public VCoreStudy() {
        this(DSL.name("v_core_study"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreStudy as(String alias) {
        return new VCoreStudy(DSL.name(alias), this);
    }

    @Override
    public VCoreStudy as(Name alias) {
        return new VCoreStudy(alias, this);
    }

    @Override
    public VCoreStudy as(Table<?> alias) {
        return new VCoreStudy(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreStudy rename(String name) {
        return new VCoreStudy(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreStudy rename(Name name) {
        return new VCoreStudy(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreStudy rename(Table<?> name) {
        return new VCoreStudy(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreStudy where(Condition condition) {
        return new VCoreStudy(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreStudy where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreStudy where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreStudy where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreStudy where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreStudy where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreStudy where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreStudy where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreStudy whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreStudy whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
